<?php

/*

CMSimple Guestbook plugin
© 2006-2010 - Joachim Barthel - www.qualifire.de/cmsimple/en
---------------------------------------------------------------------
Disclaimer:   No warranties at all, use on your own risk !
---------------------------------------------------------------------
Requirements: - CMSimple 2.5 is installed and running.
              - The plugin loader, version 1.0 beta 5 from  
                cmsimpleplugins.svarrer.dk is installed and working !
                -or-
              - The plugin loader, version 2.0 beta 9 from
                internet-setup.de/abdj_download/index.php is installed and working!  
---------------------------------------------------------------------
Feedback to:  jbarthel@qualifire.de
---------------------------------------------------------------------

*/


if(isset($gbook))
{
   GLOBAL $pth, $sl, $plugin, $tx;
   $admin= isset($_POST['admin']) ? $_POST['admin'] : $_GET['admin'];
   $action= isset($_POST['action']) ? $_POST['action'] : $_GET['action'];
   $subact= isset($_POST['subact']) ? $_POST['subact'] : $_GET['subact'];
 
   $plugin=basename(dirname(__FILE__),"/");


	$o.=print_plugin_admin('on');
	$o .= "\n<SCRIPT type=\"text/javascript\">
  /* <![CDATA[ */
  function delConfirm(cURL) {
    result = confirm('The record will be deleted.\\nPlease confirm.');
		if(result == true){
			window.location.href = cURL;
		}
	}
  /* ]]> */
	</SCRIPT>";

	if($admin<>'plugin_main'){$o.=plugin_admin_common($action,$admin,$plugin);}
	if($admin=='') {
		$o.="<h3>GBook</h3>GBook plugin Ver " . gb_Version() . " by ";
		if ($sl == "de")
			{ $o .= "<a href=\"http://www.qualifire.de/cmsimple/\" target=\"_blank\">www.qualifire.de/cmsimple/</a>"; }
		else
			{ $o .= "<a href=\"http://www.qualifire.de/cmsimple/en/\" target=\"_blank\">www.qualifire.de/cmsimple/en/</a>"; }
	}
	
  if ($admin == 'plugin_main') {
      $acturl = "http://" . $_SERVER['HTTP_HOST'] . $_SERVER['PHP_SELF'] . "?&" . $plugin . "&admin=plugin_main&action=plugin_text";

   $o.="<h3>Gbook</h3>";

   if(eregi("true",$plugin_cf['gbook']['common_guestbook'])) {
      $pth['file']['plugin_main'] = $pth['folder']['plugins'].$plugin."/content/guestbook" . ".txt";
   } else {
      $pth['file']['plugin_main'] = $pth['folder']['plugins'].$plugin."/content/guestbook_" . $sl.".txt";
   }

// ========================= Querying the import options ===========================
   if ($subact == 'cmsgbimpoptions') {
      $o .= "<div style=\"border-top: 1px solid black; width: 100%; margin-top: 10px; margin-bottom: 10px;\"></div>";
      $o .= "<strong>Import Options:</strong><br/>&nbsp;<br/>";
      $o .= "<form method=\"post\" action=\"$acturl&subact=cmsgbexecimport\">";
      $o .= "<div style=\"border: 0px solid black; padding: 6px; background: #DDDDDD;\">";
      $o .= "<strong>Save-Options</strong>";
      $o .= "<div style=\"border-top: 1px solid black; width: 40%; margin-top: 2px;\"></div>\n";
      $o .= "<input type=\"radio\" name=\"saveas\" value=\"append\" checked=\"checked\"> Append to GBook file<br/>";
      $o .= "<input type=\"radio\" name=\"saveas\" value=\"overwrite\"> Overwrite existing GBook file<br/>";
      $o .= "<br/><strong>Conversion Options</strong>";
      $o .= "<div style=\"border-top: 1px solid black; width: 40%; margin-top: 0px; padding: 0px;\"></div>\n";
      $o .= "<input type=\"checkbox\" name=\"useserver\" value=\"useserver\"> Use server name as user name<br/>";
      $o .= "<div style=\"display:none\"><input type=\"checkbox\" name=\"delhtml\" value=\"delhtml\" disabled><font color=\"gray\"> Remove HTML Code</font><br/></div>";
      $o .= "<input type=\"checkbox\" name=\"spamfilter\" value=\"spamfilter\" checked=\"checked\"> Use Spam filter<br/>";
      
      $o .= "<table padding=\"0\" spacing=\"0\" border=\"0\"><tr>";
      $o .= "<td valign=\"top\"><input type=\"text\" name=\"dscan\" value=\"%d.%d.%d %d:%d:%d\" size=\"20\" maxlength=\"25\"></td>";
      $o .= "<td valign=\"top\">Scan Format eg. \"%d.%d.%d\" for 12.05.2006 <br/>or \"%s %d. %d\" for January 20. 2006</td>";
      $o .= "</tr><tr>";
      $o .= "<td valign=\"top\"><input type=\"text\" name=\"dorder\" value=\"123456\" size=\"10\" maxlength=\"12\"></td>";
      $o .= "<td valign=\"top\">Parameter Order for 1=Day, 2=Month and 3=Year, 4=Hours, 5=Minutes and 6=Seconds</td>";
      $o .= "</tr><tr>";
      $o .= "<td valign=\"top\"><input type=\"text\" name=\"sposted\" value=\"".$tx['guestbook']['posted']."\" size=\"20\" maxlength=\"25\"></td>";
      $o .= "<td valign=\"top\">Value which is used for 'Posted'<br/>(add for CMSimple the text ' am' at the end)</td>";
      $o .= "</tr></table>";

      $o .= "<br/><strong>Other Options</strong>";
      $o .= "<div style=\"border-top: 1px solid black; width: 40%; margin-top: 2px;\"></div>\n";
      $o .= "<div style=\"display:none\"><input type=\"checkbox\" name=\"disablegb\" value=\"disablegb\" disabled><font color=\"gray\"> Disable CMSimple Guestbook</font><br/></div>";
      $o .= "<input type=\"checkbox\" name=\"gbdebug\" value=\"gbdebug\"> Debug mode<br/>";
      $o .= "<br/><strong>Info</strong><br/>";
      $o .= "<div style=\"border-top: 1px solid black; width: 40%; margin-top: 2px;\"></div>\n";
      $o .= "<table padding=\"0\" spacing=\"0\" border=\"0\"><tr>";
      $o .= "<td valign=\"top\"><input type=\"text\" name=\"dateformat\" value=\"" . $tx['guestbook']['dateformat'] . "\" size=\"10\" maxlength=\"15\" disabled>";
      $o .= "<td valign=\"top\">Used date format</td>";
      $o .= "</tr><tr>";
      $o .= "<td valign=\"top\"><input type=\"text\" name=\"lang\" value=\"" . $sl . "\" size=\"7\" maxlength=\"10\" disabled>";
      $o .= "<td valign=\"top\">Used GBook language file</td>";
      $o .= "</tr></table>";
      $o .= "</div>&nbsp;<br/>";
      $o .= "<input type=\"button\" value=\"Cancel\" onclick=\"parent.location='$acturl'\">";
      $o .= "&nbsp;&nbsp;&nbsp";
      $o .= "<input type=\"submit\" value=\" Import now ! \">";
      $o .= "</form>";
      $o .= "<br/>";
      
// ========================= Executing the import ===========================
   } elseif ($subact == 'reorggbook') {
      $o .= "<strong>Reorganizing GBook Guestbook</strong><br/>";
      $o .= "<div style=\"border: 0px solid black; padding: 6px;\">";
      //$o .= "Import-Results:";
      //$o .= "<div style=\"border-top: 1px solid black; width: 30%; margin: 2px;\"></div>";

/*      
      echo "gbImportFile=$gbImportFile<br/>";
      echo "gbSaveAs=$gbSaveAs<br/>";
      echo "gbUseServer=$gbUseServer<br/>";
      echo "gbDateFormat=$gbDateFormat<br/>";
      echo "gbDisableGB=$gbDisableGB<br/>";
*/
      
      //$o .= gb_ImportBook($gbImportFile, $gbSaveAs, $gbUseServer, $gbDelHTML, $gbDScan, $gbDOrder, $gbSPosted, $gbDisableGB, $gbDebug);
      

      $gb_file = $pth['folder']['plugins'].$plugin."/content/guestbook_".$sl.".txt";
      if($gbfh=@fopen($gb_file,"rb")) {
          $text = fread ($gbfh, filesize ($gb_file));
          fclose ($gbfh);
          $ssearch = "\\\\";
          $sreplace = "\\";
          $text = str_replace($ssearch,$sreplace,$text);
          $text = gb_conv2Smileys($text);
          $gbfh=@fopen($gb_file,"w");
          fwrite($gbfh,$text);
          fclose($gbfh);
      }
      
      $o .= "Reorganizing the GBook finished.<br/>";
      $o .= "<ul>";
      $o .= "<li>Obsolete backslash characters removed</li>";
      $o .= "<li>Smileys checked and inserted</li>";
      $o .= "</ul>";
      
      $o .= "</div>&nbsp;<br/>";
      $o .= "<button type=\"button\" onclick=\"parent.location='$acturl'\">Back to GBook data file</button>";
      
// ========================= Executing the import ===========================
   } elseif ($subact == 'cmsgbexecimport') {
      $o .= "<strong>Importing of CMSimple Guestbook</strong><br/>";
      $o .= "<div style=\"border: 0px solid black; padding: 6px;\">";
      $o .= "Import-Results:";
      $o .= "<div style=\"border-top: 1px solid black; width: 30%; margin: 2px;\"></div>";

      $gbImportFile = $pth['folder']['content'].'guestbook.txt';
      $gbSaveAs= isset($_POST['saveas']) ? $_POST['saveas'] : $_GET['saveas'];
      $gbUseServer= isset($_POST['useserver']) ? $_POST['useserver'] : $_GET['useserver'];
      $gbDelHTML= isset($_POST['delhtml']) ? $_POST['delhtml'] : $_GET['delhtml'];
      $gbDScan= isset($_POST['dscan']) ? $_POST['dscan'] : $_GET['dscan'];
      $gbDOrder= isset($_POST['dorder']) ? $_POST['dorder'] : $_GET['dorder'];
      $gbSPosted= isset($_POST['sposted']) ? $_POST['sposted'] : $_GET['sposted'];
      $gbDateFormat= isset($_POST['dateformat']) ? $_POST['dateformat'] : $_GET['dateformat'];
      $gbDisableGB= isset($_POST['disablegb']) ? $_POST['disablegb'] : $_GET['disablegb'];
      $gbDebug= isset($_POST['gbdebug']) ? $_POST['gbdebug'] : $_GET['gbdebug'];
      
/*      
      echo "gbImportFile=$gbImportFile<br/>";
      echo "gbSaveAs=$gbSaveAs<br/>";
      echo "gbUseServer=$gbUseServer<br/>";
      echo "gbDateFormat=$gbDateFormat<br/>";
      echo "gbDisableGB=$gbDisableGB<br/>";
*/
      
      $o .= gb_ImportBook($gbImportFile, $gbSaveAs, $gbUseServer, $gbDelHTML, $gbDScan, $gbDOrder, $gbSPosted, $gbDisableGB, $gbDebug);
      
      $o .= "</div>&nbsp;<br/>";
      $o .= "<button type=\"button\" onclick=\"parent.location='$acturl'\">Back to GBook data file</button>";
      
      
// ========================= Editing the selected GBook data import ===========================
   } elseif ($subact == 'cmsgbedit') {
      $o .= "<strong>Editing of CMSimple Guestbook</strong><br/>";
      $gbfile= isset($_POST['gbfile']) ? $_POST['gbfile'] : $_GET['gbfile'];
      $gbtask= isset($_POST['task']) ? $_POST['task'] : $_GET['task'];
      $gbline= isset($_POST['line']) ? $_POST['line'] : $_GET['line'];
      $o .= "<h3>".$gbfile."</h3>";
      
      if ($gbtask == "del") {
        //echo "del started: $gbfile - $gbline<br>";
        $retval = gb_DelEntry($gbfile,  $gbline);
      }
      if ($gbtask == "edit") {
        //echo "Task = EDIT";
        $o .= gb_EditEntry($gbfile,  $gbline);
      }
      if ($gbtask == "save") {
        //echo "Task = SAVE";
        $o .= gb_SaveEntry($gbfile,  $gbline);
      }
      
      $gbname = '';
      $gbemail = '';
      $gbwebsite = '';
      $gbtime = '';
      $gbdate = '';
      $gbzip = '';
      $gbcity = '';
      $gbtitle = '';
      $gbmessage = '';
      $gbipaddr = '';
      $gbtstamp = '';
      $gbpublish = '';                                          

      $gb_file = $pth['folder']['plugins'].$plugin."/content/".$gbfile;
      $gb_img = $pth['folder']['plugins'].$plugin."/images";
      if($gbfh=@fopen($gb_file,"rb")) {
          
          $o .= "<table>";
          $o .= "<tr><td><strong>Date</strong></td><td><strong>Time</strong></td><td><strong>Name</strong></td><td><strong>Title</strong></td><td><strong>Actions</strong></td></tr>";
          $lcount = 0;
          while (!feof($gbfh)) {
              $line = fgets($gbfh, 4096) . ";";
              $lcount++;
              $delUrl = "$acturl&subact=cmsgbedit&gbfile=$gbfile&task=del&line=$lcount";
              @list($gbname,$gbemail,$gbwebsite,$gbtime,$gbdate,$gbtitle,$gbmessage,$gbipaddr,$gbtstamp,$gbzip,$gbcity,$gbpublish) = split(";", $line);
			  if ((!empty($gbmessage)) || (!feof($gbfh)))
                  $o .= "<tr><td>$gbdate</td><td>$gbtime</td><td>$gbname</td><td>$gbtitle</td><td>&nbsp;"
                    . "<a href=\"$acturl&subact=cmsgbedit&gbfile=$gbfile&task=edit&line=$lcount\"><img src=\"$gb_img/editentry.png\"/></a>&nbsp;&nbsp;"
                    . "<a href=\"javascript:delConfirm('$delUrl');\"><img src=\"$gb_img/delentry.png\"/></a></td></tr>";
          }
          $o .= "</table>";
          fclose($gbfh);
      }
      
   
   
   
// ========================= Showing/Editing the GBook data file ===========================
} else {
      $o .= "<script language=\"JavaScript\">\n";
      $o .= "function gb_showServerInfo()";
      $o .= "{";
      $o .= "Fenster = window.open('http://localhost:808/cms/plugins/gbook/wsinfo.php','Fenster', 'location=no, menubar=no, resizable=yes, toolbar=no');";
      $o .= "Fenster.focus();";
      $o .= "}\n";
      $o .= "</script>\n";

      $o .= "<div style=\"border-top: 1px solid black; width: 100%; margin-top: 10px; margin-bottom: 10px;\"></div>";
      $o .= "<strong>Advanced Options:</strong><br/>&nbsp;<br/>";
      $o .= "<button type=\"button\" style=\"width:150px\" onclick=\"parent.location='$acturl&subact=reorggbook'\">Reorg Guestbook</button>";
      $o .= " - Reorganize the GBook guestbook file<br/>";
      $o .= "<div style=\"border-top: 3px solid transparent; width: 40%; margin-top: 2px;\"></div>";
      $o .= "<button type=\"button\" style=\"width:150px\" onclick=\"parent.location='$acturl&subact=cmsgbimpoptions'\">Import Guestbook</button>";
      $o .= " - Import the default guestbook from CMSimple<br/>";
      $o .= "<div style=\"border-top: 0px solid black; width: 100%; margin-top: 10px; margin-bottom: 10px;\"></div>";

      $o .= "<h4>Edit the GBook data</h4><p>";
      
      $o .= "<form name=\"gbedit\">";
    	
      $gb_contpath .= $pth['folder']['plugins'].$plugin."/content";
      
      $d = dir($gb_contpath);
      $gb_fnames = array();
    	$fcount = 0;
    	$o .= "<select name=\"gbcontname\" id=\"gbcontname\" size=\"1\" style=\"width:150px\">";
    	
    	while (false !== ($entry = $d->read())) {
        if ($entry != "." && $entry != "..") {
        		if (eregi(".txt$",$entry)) {
        			$fcount++;
        			array_push($gb_fnames, $entry);
        			//$o .= $fcount." -- ".$gb_fnames[$fcount-1]."<br />";
        			$o .= "<option value=\"".$gb_fnames[$fcount-1]."\">".$gb_fnames[$fcount-1]."</option>";
        		}
        }
    	}
    	$o .= "</select>";
    	$o .= "&nbsp;&nbsp;<button type=\"button\" style=\"width:150px\" "
            . "onclick=\"parent.location='$acturl&subact=cmsgbedit&gbfile='+document.gbedit.gbcontname.value\">Edit</button>";
    	
    	$d->close();
    	$fcount--;
    	$o .= "</form>";

      
      $o .= "<br/><hr/><br/>" . $plugin_tx['gbook']['txt_change_data'] . "<br/>";
      $o .= plugin_admin_common($action,$admin,$plugin);
   }


  }
}



function gb_ImportBook($gbImportFile, $gbSaveAs, $gbUseServer, $gbDelHTML,  $gbDScan, $gbDOrder, $gbSPosted, $gbDisableGB, $gbDebug) {
   GLOBAL $pth, $sl, $tx, $plugin, $plugin_cf;
   
   $rTxt = "<br/>" . $cGbookFile;
   
   $lineCount = 0;
   $spamCount = 0;
   $firstLine = 0;
   $gbNameArray = array();
   $gbEmailArray = array();
   $gbWebsiteArray = array();
   $gbTimeArray = array();
   $gbDateArray = array();
   $gbTitleArray = array();
   $gbMessageArray = array();
   $gbIpaddrArray = array();
   $handle = fopen ($gbImportFile, "r");
   
   $gbDateForm = $tx['guestbook']['dateformat'];
   $gbPostAt = $tx['guestbook']['posted'];

	    $pos1 = substr($gbDOrder,0,1)-1;
	    $pos2 = substr($gbDOrder,1,1)-1;
	    $pos3 = substr($gbDOrder,2,1)-1;
	    $pos4 = substr($gbDOrder,3,1)-1;
	    $pos5 = substr($gbDOrder,4,1)-1;
	    $pos6 = substr($gbDOrder,5,1)-1;

	    $cexist = strchr($gbDateForm, 'F');

   //error_reporting(E_ALL);
   if ($gbDebug == "gbdebug") echo date("H:i:s")." - Starting the Import<hr/>";

   $cLine = "";
   while (!feof($handle)) {
      $tmpLine = fgets($handle);
      
      if ($firstLine == 0) {
         $firstLine = 1;
      } else {
         if (eregi("<small>.+<\/small>", $tmpLine)) {     // Header-Line found
            $lineCount++;
            
            $gbemail = "";
            $gbname = "";
            $gbtitle = "";
            $gbwebsite = "";
            
            $regExpr = "(<small>)(.+)(<\/small>.+)";
            $tmpLine = eregi_replace($regExpr, "\\2", $tmpLine);
            // return something like  "Gesendet am May 05. 2006 14:02:51 von 127.0.0.1"
            if ($gbDebug == "gbdebug") echo "tmpLine = $tmpLine<br/>";
            
            $gbemail = trim(substr($tmpLine,strpos($tmpLine,'mailto:')+strlen('mailto:')));
            //if ($gbDebug == "gbdebug") echo "gbemail = $gbemail<br/>";
            $gbname = $gbemail;
            $gbemail = substr($gbemail,0,strpos($gbemail,'>'));
            if ($gbDebug == "gbdebug") echo "gbemail = $gbemail<br/>";
            
            $gbname = trim(substr($gbname,strpos($gbname,'>')+1));
            $gbname = trim(substr($gbname,0,strpos($gbname,'</a>')));
            if ($gbDebug == "gbdebug") echo "gbname = $gbname<br/>";
            
            $tmpLine = trim(substr($tmpLine,strpos($tmpLine,$gbSPosted)+strlen($gbSPosted)));
            // return something like  "May 05. 2006 14:02:51 von 127.0.0.1"
            
//-----------------------------------------------------------------------------------------------------

            $gbipaddr = gb_strrnum($tmpLine);
            if ($gbDebug == "gbdebug") echo "gbipaddr = $gbipaddr<br/>";

	    $gbdatetxt = $tmpLine;
            if ($gbDebug == "gbdebug") echo "gbdatetxt = $gbdatetxt<br/>";
	    
	    $gbvars = sscanf($gbdatetxt,$gbDScan);
            if ($gbDebug == "gbdebug") echo date("H:i:s")." - ";
            if ($gbDebug == "gbdebug") print_r($gbvars);
            if ($gbDebug == "gbdebug") echo "<br/>";
	    
	    if ($cexist <> ""){
	       $tmpDate = $gbvars[$pos1] . " " . $gbvars[$pos2] . " " . $gbvars[$pos3];
	       $gbdate = date("d.m.Y",strtotime($tmpDate));
	    } else {
	       $gbdate = date("d.m.Y",mktime(0, 0, 0, $gbvars[$pos2], $gbvars[$pos1], $gbvars[$pos3]));
	    }
	    $gbtime = date("H:i:s",mktime($gbvars[$pos4],$gbvars[$pos5],$gbvars[$pos6]));
            if ($gbDebug == "gbdebug") echo date("H:i:s")." - ";
            if ($gbDebug == "gbdebug") echo "gbtime = ".$gbtime.", gbdate = ".$gbdate."<hr/>";



//-----------------------------------------------------------------------------------------------------

            $startTime = gb_microtime_float();
            if ($gbUseServer == "useserver") {
               $gbname = "";
               $gbname = @gethostbyaddr($gbipaddr);
            }
            if (gb_microtime_float()-$startTime > 1.0) {
               $gbUseServer = "";
               //$gbname = "";
               $cLine .=  "<strong>Warning:</strong> Timeout on GetHostByAddr<br/>";
            }
            
            $tmpLine = fgets($handle);
            $gbLine = eregi_replace("<hr/>", "", $tmpLine);
            while ((!feof($handle)) && (!eregi("<hr/>",$tmpLine))) {
               $tmpLine = fgets($handle);
               $gbLine .= eregi_replace("<hr/>", "", $tmpLine);
            }
            $gbLine = gb_conv2Smileys($gbLine);
      $asrctxt = array (chr(92).chr(34),
                        chr(92).chr(39),
                        chr(10).chr(13),
                        chr(13),
                        chr(10),
                        //"&gt;",
                        //"&lt;",
                        ";");

      $areptxt = array (chr(34),
                        chr(39),
                        "<br/>",
                        "<br/>",
                        "<br/>",
                        //">",
                        //"<",
                        ",");            
            $gbLine = str_replace($asrctxt, $areptxt, $gbLine);
            
            if (!eregi($plugin_cf['gbook']['blocked_words'], $gbLine)) {
               array_push($gbNameArray, $gbname);
               array_push($gbEmailArray, $gbemail);
               array_push($gbWebsiteArray, $gbwebsite);
               array_push($gbTimeArray, $gbtime);
               array_push($gbDateArray, $gbdate);
               array_push($gbTitleArray, $gbtitle);
               array_push($gbIpaddrArray, $gbipaddr);
               array_push($gbMessageArray, $gbLine);
            } else {
               $lineCount--;
               $spamCount++;
            }
            
         }
      }


   }

   $lineCount--;
   fclose ($handle);
   
   $pth['file']['plugin_main'] = $pth['folder']['plugins'].$plugin."/content/guestbook_".$sl.".txt";
   
   if ($gbSaveAs == "overwrite") {
      $handle = fopen ($pth['file']['plugin_main'], "w");
      $nltxt = "";
   } else {
      $handle = fopen ($pth['file']['plugin_main'], "a");
      $nltxt = "\n";
   }
   
   for ($i = $lineCount; $i >= 0; $i--) {
      $gbentry = $nltxt . $gbNameArray[$i] .";"
         . $gbEmailArray[$i] .";"
         . $gbWebsiteArray[$i] .";"
         . $gbDateArray[$i] .";"
         . $gbTimeArray[$i] .";"
         . $gbTitleArray[$i] .";"
         . $gbMessageArray[$i] .";"
         . $gbIpaddrArray[$i];
      fputs($handle,$gbentry);
      $nltxt = "\n";
   }
   fclose ($handle);

   $lineCount++;
   $cLine .= "\n";
   $cLine .= "<br/> <br/><strong>Summary:</strong><br/>\n";
   $cLine .= "$lineCount guestbook messages imported<br/>\n";
   $cLine .= "$spamCount spam messages ignored<br/>\n";
   
   $rTxt .= "<br/><div style=\"border: 0px solid black; padding: 6px; background: #EEEEEE;\">" . $cLine . "</div>";
   
   return $rTxt;
}



function gb_DisplaySource($cSourceText) {
   $asrctxt = array ("/&lt;/",
                 "/&gt;/",
                 "/</",  
                 "/>/",
                 "/\n/");     

   $areptxt = array ("&amp;lt;",
                  "&amp;gt;",
                  "&lt;",
                  "&gt;",
                  "<br/>");

   return preg_replace($asrctxt, $areptxt, $cSourceText);
}



function gb_BackupData() {

   $rTxt = "";
   if (!copy($file, $file.'.bak')) {
      $rTxt .= "failed to copy $file...<br/>\n";
   } else {
      $rTxt .= "Backup created for $file...<br/>\n";
   }

   return "True";
}



function gb_DelEntry ($gbfile, $gbline) {

    GLOBAL $pth, $sl, $plugin, $tx;
    
    $text = "";
    $gb_file = $pth['folder']['plugins'].$plugin."/content/".$gbfile;
    if($gbfh=@fopen($gb_file,"rb")) {
        $lcount = 1;
        while (!feof($gbfh)) {
          $line = fgets($gbfh, 4096);
          if ($lcount <> $gbline)
              $text .= $line; 
          $lcount++;
        }
        fclose($gbfh);
        
        $gbfh=@fopen($gb_file,"w");
        fwrite($gbfh,$text);
        fclose($gbfh);
    }
    
    return "True";

}



function gb_EditEntry ($gbfile, $gbline) {

    GLOBAL $pth, $sl, $plugin, $tx;
    
    $text = "";
    $gb_file = $pth['folder']['plugins'].$plugin."/content/".$gbfile;
	$acturl = "http://" . $_SERVER['HTTP_HOST'] . $_SERVER['PHP_SELF'] . "?&" . $plugin . "&admin=plugin_main&action=plugin_text";
	echo $acturl;
    
    if($gbfh=@fopen($gb_file,"rb")) {
        $lcount = 1;
        while (!feof($gbfh)) {
          $line = fgets($gbfh, 4096).";";
          if ($lcount == $gbline) {
              // do it
              $gbname = '';
              $gbemail = '';
              $gbwebsite = '';
              $gbtime = '';
              $gbdate = '';
              $gbzip = '';
              $gbcity = '';
              $gbtitle = '';
              $gbmessage = '';
              $gbipaddr = '';
              $gbtstamp = '';
              $gbpublish = '';

              @list($gbname,$gbemail,$gbwebsite,$gbtime,$gbdate,$gbtitle,$gbmessage,$gbipaddr,
              $gbtstamp,$gbzip,$gbcity,$gbpublish) = split(";", $line);
              if (trim($gbpublish) == 'yes')
                  $gbpublishchecked = 'checked';
              else
                  $gbpublishchecked = '';

              $text = '<p><form action="'.$acturl.'&subact=cmsgbedit&gbfile='.$gbfile.'&line='.$gbline.'" method="post">'
                      . '<table width="80%">'
                      . '<tr>'
                      . '<td><small>Date</small><br /><input class="gbtextbox" type="text" name="gbdate" value="'.$gbdate.'" size="30" maxlength="80"></td>'
                      . '<td><small>Time</small><br /><input class="gbtextbox" type="text" name="gbtime" value="'.$gbtime.'" size="30" maxlength="80"></td>'
                      . '</tr>'
                      . '<tr>'
                      . '<td><small>Name</small><br /><input class="gbtextbox" type="text" name="gbname" value="'.$gbname.'" size="30" maxlength="80"></td>'
                      . '<td><small>E-Mail</small><br /><input class="gbtextbox" type="text" name="gbemail" value="'.$gbemail.'" size="30" maxlength="80"></td>'
                      . '</tr>'
                      . '<tr>'
                      . '<td colspan="2"><small>Homepage</small><br /><input class="gbtextbox" type="text" name="gbwebsite" value="'.$gbwebsite.'" size="64" maxlength="80"></td>'
                      . '</tr>'
                      . '<tr>'
                      . '<td><small>ZIP</small><br /><input class="gbtextbox" type="text" name="gbzip" value="'.$gbzip.'" size="30" maxlength="80"></td>'
                      . '<td><small>City</small><br /><input class="gbtextbox" type="text" name="gbcity" value="'.$gbcity.'" size="30" maxlength="80"></td>'
                      . '</tr>'
                      . '<tr>'
                      . '<tr>'
                      . '<td colspan="2"><small>Title</small><br /><input class="gbtextbox" type="text" name="gbtitle" value="'.$gbtitle.'" size="64" maxlength="80"></td>'
                      . '</tr>'
                      . '<tr>'
                      . '<td colspan="2"><small>Message</small><br /><textarea class="gbmsgbox" name="gbmessage" cols="30" rows="5">'.$gbmessage.'</textarea></td>'
                      . '</tr>'
                      . '<td><input type="checkbox" name="gbpublish" '.$gbpublishchecked.'">Further publishing allowed</td>'
                      . '</tr>'
                      . '</table><br />'
                      . '<input type="hidden" name="gbipaddr" value="'.$gbipaddr.'">'
                      . '<input type="hidden" name="gbtstamp" value="'.$gbtstamp.'">'
                      . '<input type="hidden" name="task" value="save">'
                      . '<input type="submit" value="Save Changes">'
                      . '</form></p><hr />';
          }
          $lcount++;
        }
        fclose($gbfh);
    }
    
    return $text;

}



function gb_SaveEntry ($gbfile, $gbline) {

    GLOBAL $pth, $sl, $plugin, $tx;

    $gb_file = $pth['folder']['plugins'].$plugin."/content/".$gbfile;

    $gbname = isset($_POST['gbname']) ? $_POST['gbname'] : $_GET['gbname'];
    $gbemail = isset($_POST['gbemail']) ? $_POST['gbemail'] : $_GET['gbemail'];
    $gbwebsite = isset($_POST['gbwebsite']) ? $_POST['gbwebsite'] : $_GET['gbwebsite'];
    $gbtime = isset($_POST['gbtime']) ? $_POST['gbtime'] : $_GET['gbtime'];
    $gbdate = isset($_POST['gbdate']) ? $_POST['gbdate'] : $_GET['gbdate'];
    $gbzip = isset($_POST['gbzip']) ? $_POST['gbzip'] : $_GET['gbzip'];
    $gbcity = isset($_POST['gbcity']) ? $_POST['gbcity'] : $_GET['gbcity'];
    $gbtitle = isset($_POST['gbtitle']) ? $_POST['gbtitle'] : $_GET['gbtitle'];
    $gbmessage = isset($_POST['gbmessage']) ? $_POST['gbmessage'] : $_GET['gbmessage'];
    $gbipaddr = isset($_POST['gbipaddr']) ? $_POST['gbipaddr'] : $_GET['gbipaddr'];
    $gbtstamp = isset($_POST['gbtstamp']) ? $_POST['gbtstamp'] : $_GET['gbtstamp'];
    $gbpublish = isset($_POST['gbpublish']) ? $_POST['gbpublish'] : $_GET['gbpublish'];                                          
    if (empty($gbpublish))
        $gbpublish = 'no';
    else
        $gbpublish = 'yes';

    $text = "";
    $gb_file = $pth['folder']['plugins'].$plugin."/content/".$gbfile;
    if($gbfh=@fopen($gb_file,"rb")) {
        $lcount = 1;
        while (!feof($gbfh)) {
          $line = fgets($gbfh, 4096);
          if ($lcount <> $gbline) {
              $text .= $line;
          }
          else {
              $line = str_replace(array("\r", "\n"), '', $gbname) . ';'
                    . str_replace(array("\r", "\n"), '', $gbemail) . ';'
                    . str_replace(array("\r", "\n"), '', $gbwebsite) . ';'
                    . str_replace(array("\r", "\n"), '', $gbtime) . ';'
                    . str_replace(array("\r", "\n"), '', $gbdate) . ';'
                    . str_replace(array("\r", "\n"), '', $gbtitle) . ';'
                    . $gbmessage . ';'
                    . str_replace(array("\r", "\n"), '', $gbipaddr) . ';'
                    . str_replace(array("\r", "\n"), '', $gbtstamp) . ';'
                    . str_replace(array("\r", "\n"), '', $gbzip) . ';'
                    . str_replace(array("\r", "\n"), '', $gbcity) . ';'
                    . str_replace(array("\r", "\n"), '', $gbpublish) . "\n";
              $text .= $line;
          } 
          $lcount++;
        }
        fclose($gbfh);
        
        $gbfh=@fopen($gb_file,"w");
        fwrite($gbfh,$text);
        fclose($gbfh);
    }
    
    return "True";

}



function gb_strlnum ($ctxt) {

$i = 0;
$tchar = substr($ctxt,$i,1);
while (ereg("[0-9. :\/]",$tchar)){
   $i++;
   $tchar = substr($ctxt,$i,1);
}
$i--;
return substr($ctxt,0,$i);

}



function gb_strrnum ($ctxt) {

$i = -1;
$tchar = substr($ctxt,$i,1);
while (ereg("[0-9.:\/]",$tchar)){
   $i--;
   $tchar = substr($ctxt,$i,1);
}
$i++;
return substr($ctxt,$i);

}



function gb_microtime_float()
{
    list($usec, $sec) = explode(" ", microtime());
    return ((float)$usec + (float)$sec);
}

?>
